/*
 *	sha1.h
 *
 *	Copyright (C) 1998
 *	Paul E. Jones <paulej@arid.us>
 *	All Rights Reserved.
 *
 *****************************************************************************
 *	$Id: sha1.h,v 1.6 2004/03/27 18:02:26 paulej Exp $
 *****************************************************************************
 *
 *	Description:
 * 		This class implements the Secure Hashing Standard as defined
 * 		in FIPS PUB 180-1 published April 17, 1995.
 *
 *		Many of the variable names in this class, especially the single
 *		character names, were used because those were the names used
 *		in the publication.
 *
 * 		Please read the file sha1.cpp for more information.
 *
 * 		This is the same as MD5.
 * /*
 *  Created on: 2009-3-26
 *      Author: root
 *      usage	:	char SHABuffer[41];
 *					SHA1 SHA;
 *					SHA.SHA_GO("gfc",SHABuffer);
 *					ִ֮SHABufferм洢"a string"õSHAֵ
 		㷨
					1.γ512 bits(64ֽ), (N+1)*512;
								N*512 + 448λ                         64λ
						ʵ + (һ10)		 		ʵݵĳ
						 ----------------------
					2.ĸ32λΪӱ
						A=B=C=D=,E=
					3.ʼ㷨ѭ㡣
						ѭĴ(N+1)Ϣ512λϢĿ
						for(N+1, ÿȡ512 bits(64ֽ)д)
						{
							512bits ֳ16(ÿ4ֽڡint data[16])
							16еÿһABCD,Eͨ4㣬
							õµABCD,E
						}
					4.󣬽ABCD,EƴSHAֵ
						ƴӺֵַķʽʾյĽ
						( 0x234233F, ô 234233FʾɵĴĿռ佫ֵĿռ2)
 *		: ôѾͨ
 */

#ifndef _SHA1_H_
#define _SHA1_H_

#include<string.h>
#include<stdio.h>

class SHA1
{
	public:
		SHA1();
		virtual ~SHA1();
		bool SHA_GO(const char *lpData_Input, char *lpSHACode_Output );
	private:
		unsigned int H[5];					// Message digest buffers
		unsigned int Length_Low;				// Message length in bits
		unsigned int Length_High;			// Message length in bits
		unsigned char Message_Block[64];	// 512-bit message blocks
		int Message_Block_Index;				// Index into message block array
	private:
		void SHAInit();
		void AddDataLen(int nDealDataLen);

		// Process the next 512 bits of the message
		void ProcessMessageBlock();

		// Pads the current message block to 512 bits
		void PadMessage();

		// Performs a circular left shift operation
		inline unsigned CircularShift(int bits, unsigned word);
};

#endif
